Index: uspace/lib/c/generic/adt/char_map.c
===================================================================
--- uspace/lib/c/generic/adt/char_map.c	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/generic/adt/char_map.c	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libc 
+/** @addtogroup libc
  *  @{
  */
Index: uspace/lib/c/generic/adt/dynamic_fifo.c
===================================================================
--- uspace/lib/c/generic/adt/dynamic_fifo.c	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/generic/adt/dynamic_fifo.c	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libc
  *  @{
  */
Index: uspace/lib/c/generic/adt/measured_strings.c
===================================================================
--- uspace/lib/c/generic/adt/measured_strings.c	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/generic/adt/measured_strings.c	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libc
  *  @{
  */
Index: uspace/lib/c/include/adt/char_map.h
===================================================================
--- uspace/lib/c/include/adt/char_map.h	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/include/adt/char_map.h	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libc 
+/** @addtogroup libc
  *  @{
  */
@@ -35,6 +35,6 @@
  */
 
-#ifndef __CHAR_MAP_H__
-#define __CHAR_MAP_H__
+#ifndef LIBC_CHAR_MAP_H_
+#define LIBC_CHAR_MAP_H_
 
 #include <libarch/types.h>
Index: uspace/lib/c/include/adt/dynamic_fifo.h
===================================================================
--- uspace/lib/c/include/adt/dynamic_fifo.h	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/include/adt/dynamic_fifo.h	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libc
  *  @{
  */
@@ -36,6 +36,6 @@
  */
 
-#ifndef __NET_DYNAMIC_FIFO_H__
-#define __NET_DYNAMIC_FIFO_H__
+#ifndef LIBC_DYNAMIC_FIFO_H_
+#define LIBC_DYNAMIC_FIFO_H_
 
 /** Type definition of the dynamic fifo queue.
Index: uspace/lib/c/include/adt/generic_char_map.h
===================================================================
--- uspace/lib/c/include/adt/generic_char_map.h	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/include/adt/generic_char_map.h	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libc
  *  @{
  */
@@ -35,6 +35,6 @@
  */
 
-#ifndef __GENERIC_CHAR_MAP_H__
-#define __GENERIC_CHAR_MAP_H__
+#ifndef LIBC_GENERIC_CHAR_MAP_H_
+#define LIBC_GENERIC_CHAR_MAP_H_
 
 #include <unistd.h>
Index: uspace/lib/c/include/adt/generic_field.h
===================================================================
--- uspace/lib/c/include/adt/generic_field.h	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/include/adt/generic_field.h	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libc
  *  @{
  */
@@ -35,6 +35,6 @@
  */
 
-#ifndef __GENERIC_FIELD_H__
-#define __GENERIC_FIELD_H__
+#ifndef LIBC_GENERIC_FIELD_H_
+#define LIBC_GENERIC_FIELD_H_
 
 #include <errno.h>
Index: uspace/lib/c/include/adt/int_map.h
===================================================================
--- uspace/lib/c/include/adt/int_map.h	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/include/adt/int_map.h	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libc
  *  @{
  */
@@ -35,6 +35,6 @@
  */
 
-#ifndef __NET_INT_MAP_H__
-#define __NET_INT_MAP_H__
+#ifndef LIBC_INT_MAP_H_
+#define LIBC_INT_MAP_H_
 
 #include <errno.h>
Index: uspace/lib/c/include/adt/measured_strings.h
===================================================================
--- uspace/lib/c/include/adt/measured_strings.h	(revision 3c213f6e05d62f758d8643c6407493d1071d6526)
+++ uspace/lib/c/include/adt/measured_strings.h	(revision 254444258962a4784495752977900a9dea514caa)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libc 
+/** @addtogroup libc
  *  @{
  */
@@ -37,6 +37,6 @@
  */
 
-#ifndef __MEASURED_STRINGS_H__
-#define __MEASURED_STRINGS_H__
+#ifndef LIBC_MEASURED_STRINGS_H_
+#define LIBC_MEASURED_STRINGS_H_
 
 #include <sys/types.h>